<?php
/**
 * @version    1.00.0003 SVN: $Id: header.php 80 2010-03-21 12:52:39Z dw.ilya $
 * @package    DiscussionsAvatars
 * @subpackage Base
 * @author     Ilya Vikharev {@link http://factory.docwriter.ru/}
 * @author     Created on 31-Dec-2010
 * @copyright  2010 Factory.DocWriter.Ru
 * @license    GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @since      File available since Release 1.00
 */

//-- No direct access
defined('_JEXEC') or die('Direct access not alowed.');

jimport('joomla.plugin.plugin');

/**
 * Example System Plugin
 *
 * @package    DiscussionsAvatars
 * @subpackage	Plugin
 */
class plgSystemDiscussionsAvatars extends JPlugin
{
    /**
     * Constructor
     *
     * For php4 compatability we must not use the __constructor as a constructor for plugins
     * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
     * This causes problems with cross-referencing necessary for the observer design pattern.
     *
     * @access      protected
     * @param       object  $subject The object to observe
     * @param       array   $config  An array that holds the plugin configuration
     */
    function plgSystemDiscussionsAvatars( &$subject, $config )
    {
        parent::__construct( $subject, $config );

        // Do some extra initialisation in this constructor if required
    }//function

    /**
     * Do something onAfterInitialise
     */
    function onAfterInitialise()
    {
    }//function

    /**
     * Do something onAfterRoute
     */
    function onAfterRoute()
    {
    }//function

    /**
     * Do something onAfterDispatch
     */
    function onAfterDispatch()
    {
    }//function
    
    function _getAvatar ($user) {
        
        $result = null;
        
        $db =& JFactory::getDBO();
        
        $query = "SELECT `c`.`avatar` FROM `#__comprofiler` `c` LEFT JOIN `#__users` `u` ON `c`.`user_id` = `u`.`id` WHERE `u`.`username` = '$user'";
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result) {
            if (strpos($result, '/') <= 0) {
                // Use thumbnali
                $result = "tn$result";
            }
            $result = JURI::root() . 'images/comprofiler/' . $result;
        }
        
        return $result;
    }

    /**
     * Do something onAfterRender
     */
    function onAfterRender()
    {
        $option = JRequest::getCmd('option');
        $buffer = JResponse::getBody();
        
        if ($option == 'com_discussions') {
            /*$buffer = preg_replace('/(<img\s.*?)(?:src\s*=\s*\"?.*?\/com_discussions\/assets\/users\/user.png\"?)(\s*.*?>)/', '\1src="' . JURI::root() . '/images/powered_by.png"\2', $buffer);*/
            $pattern = '/(<img\s.*?src\s*=\s*["\'])(.*?\/com_discussions\/assets\/users\/user.png)(["\']\s*.*?alt\s*=\s*["\'](.*?)["\'].*?>)/';
            $avatars = array();
            
            preg_match_all($pattern, $buffer, $avatars);
            
            for ($i = 0; $i <= sizeof($avatars[0]) - 1; $i++) {
                $curImage = $avatars[0][$i];
                $curPre = $avatars[1][$i];
                $curPost = $avatars[3][$i];
                $curAlt = $avatars[4][$i];
                $curAvatar = $this->_getAvatar($curAlt);
                if ($curAvatar) {
                    $curSub = $curPre . $curAvatar . $curPost;
                    $curPos = strpos($buffer, $curImage);
                    $curLen = strlen($curImage);
                    if ($curPos > 0) {
                        $buffer = substr_replace($buffer, $curSub, $curPos, $curLen);
                    }
                }
            }
            
            JResponse::setBody($buffer);
        }
    }//function

}//class
